//--- OBJECT WRITE BEGIN ---
new GuiControl(NotepadGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 2";
   visible = "1";
   helpTag = "0";

   new GuiWindowCtrl(NotepadGUI_Window) {
      profile = "TBM_WindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "193 76";
      extent = "454 332";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Notepad";
      maxLength = "255";
      resizeWidth = "0";
      resizeHeight = "0";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
      closeCommand = "Canvas.popDialog(NotepadGUI);";

     new GuiMenuBar(NotepadGUI_Menu) {
        profile = "GuiMenuBarProfile";
        horizSizing = "width";
        vertSizing = "bottom";
        position = "3 24";
        extent = "450 22";
        minExtent = "8 8";
        visible = "1";
        helpTag = "0";
     };

      new GuiScrollCtrl(NotepadGUI_scroller) {
         profile = "TBM_ScrollProfile";
         horizSizing = "width";
         vertSizing = "height";
         position = "3 46";
         extent = "450 286";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "alwaysOn";
         constantThumbHeight = "0";
         childMargin = "1 0";

         new GuiMLTextEditCtrl(NotepadGUI_text) {
            profile = "GuiMLTextEditProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "3 2";
            extent = "400 102";
            minExtent = "8 2";
            visible = "1";
            helpTag = "0";
            lineSpacing = "1";
            allowColorChars = "0";
         };
      };
   };
};

new GuiControl(NotepadGUI_Openfilepopup) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "400 150";
   minExtent = "8 2";
   visible = "1";
   helpTag = "0";

   new GuiWindowCtrl() {
      profile = "TBM_WindowProfile";
      horizSizing = "right";
      vertSizing = "bottom";
      position = "337 195";
      extent = "280 100";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Open File";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "1";
      canMaximize = "1";
      minSize = "50 50";
      closeCommand = "canvas.popDialog(NotepadGUI_OpenFilePopup);";


      new GuiTextCtrl() {
         profile = "GuiTextProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "5 30";
         extent = "186 24";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
	 text = "Open this file:";
         maxLength = "255";
      };
      new GuiTextEditCtrl(NotepadGUI_Openfilepopup_filename) {
         profile = "GuiTextEditProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "95 30";
         extent = "180 18";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         maxLength = "255";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
      };

      new GuiButtonCtrl() {
         profile = "TBM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = "110 65";
         extent = "60 26";
         minExtent = "8 2";
         visible = "1";
         command = "NotepadGUI_Open();";
         accelerator = "return";
         helpTag = "0";
         text = "OK";
         groupNum = "-1";
         buttonType = "PushButton";
      };

   };
};

//--- OBJECT WRITE END ---

//Executed when the file is loaded.
if(!isobject($NotepadGUI_fileobject))
 $NotepadGUI_fileobject = new FileObject();

NotepadGUI_Menu.clearMenus();
NotepadGUI_Menu.addMenu("File", 0);
NotepadGUI_Menu.addMenuItem("File", "Open", 1, "Alt O");
NotepadGUI_Menu.addMenuItem("File", "Open Notes", 2);
NotepadGUI_Menu.addMenuItem("File", "Save", 3, "Alt S");
NotepadGUI_Menu.addMenuItem("File", "Exec File", 4, "Alt X");
NotepadGUI_Menu.addMenuItem("File", "Close", 5);
NotepadGUI_Menu.addMenu("Tools (Ha ha, just kidding.)", 1);

$NotepadGUI_Openedfile = "";

function NotepadGUI_Menu::onMenuItemSelect(%this, %menuId, %menu, %itemId, %item) {
if(%item $= "Open") canvas.pushdialog(NotepadGUI_OpenFilePopup);
if(%item $= "Open Notes") NotepadGUI_loadfile("Dtb/Client/Wiggy/Notes.txt");
if(%item $= "Save") NotepadGUI_savefile(1);
if(%item $= "Exec File") MessageBoxYesNo( "Save?", "Do you want to save?", "NotepadGUI_savefile(0);NotepadGUI_execfile();", "NotepadGUI_execfile();");
if(%item $= "Close") Canvas.popDialog(NotepadGUI);
}

function NotepadGUI_Open() {
NotepadGUI_loadfile(NotepadGUI_Openfilepopup_filename.getvalue());
canvas.popdialog(NotepadGUI_Openfilepopup);
}

function NotepadGUI_loadfile(%filename) {
if(!getlinecount(%filename)) {
 error("Error:" SPC %filename SPC "does not exist, or is empty.");
 MessageBoxOK("Error!", %Filename SPC "does not exist, or is empty.");
 return;
}
if(%filename !$= "Dtb/Client/Wiggy/Notes.txt" && getsubstr(%filename,strlen(%filename)-3,strlen(%filename)) !$= ".cs") {
 error("Error:" SPC %filename SPC "is not a .cs file.");
 MessageBoxOK("Error!", %Filename SPC "is not a .cs file.");
 return;
}
NotepadGUI_Text.setvalue("");
$NotepadGUI_Openedfile = %filename;
%file = $NotepadGUI_fileobject;
%file.openforread(%filename);
%string = %file.readline();
while(!%file.isEOF()) {
  %string = %string @ "\n" @ %file.readLine();
  }
%file.close();
NotepadGUI_text.settext(%string);
NotepadGUI_Window.settext("Notepad -" SPC %filename);
if(%filename $= "Dtb/Client/Wiggy/Notes.txt")
NotepadGUI_Window.settext("Notepad - Notes");
}

function NotepadGUI_savefile(%msg) {
if($NotepadGUI_Openedfile $= "") {
 error("Error: somehow, no file has been opened.");
 return;
}
%file = $NotepadGUI_fileobject;
%file.openforwrite($NotepadGUI_Openedfile);
for(%i=0;%i<10000;%i++) {
 %a = disectfilename(NotepadGUI_text.gettext()@"\n--END--\n","\n",%i);
 if(%a $= "--END--")
  %i = 10001;
 else
  %file.writeline(%a);
}
%file.close();
if(%msg) MessageBoxOK("Saved!","The file has been saved.");
}

function NotepadGUI_execfile() {
if($NotepadGUI_Openedfile $= "") {
 error("Error: somehow, no file has been opened.");
 return;
}
%filename = $NotepadGUI_Openedfile;
if(getsubstr(%filename,strlen(%filename)-3,strlen(%filename)) !$= ".cs") {
 error("Error:" SPC %filename SPC "is not a .cs file.");
 MessageBoxOK("Error!", %Filename SPC "is not a .cs file.");
 return;
}
exec($NotepadGUI_Openedfile);
MessageBoxOK("Done", %Filename SPC "has been executed - check the console to see if there were any errors.");
}

function opennotepad() {
canvas.pushdialog(NotepadGUI);
}


//Chat and slash-command hooks
package Wiggy_Notepad {
function MessageHud_Edit::eval(%this) {
%text = %this.getvalue();
if(getword(%text,0) $= "/notepad") {
	canvas.pushdialog(NotepadGUI);
	MessageHUD.close();
	return;
}
Parent::Eval(%this);
}

function slashhelp_returncommandlist() {
return Parent::slashhelp_returncommandlist() SPC "/notepad";
}

function slashhelp(%a) {
if(%a $= "/notepad" || %a $= "notepad") {
  ChatHUD.addline("\c4/notepad");
  ChatHUD.addline("\c3Opens the Notepad.");
  return;
}
Parent::slashhelp(%a);
}

};
activatepackage(Wiggy_Notepad);