//BEGIN
if(isObject(StopwatchGUI)) {
  if(StopwatchGUI.isAwake()) {
    canvas.popDialog(StopwatchGUI);
    error("The stopwatch is already open!  Close a GUI before you execute it again, bonehead.");
  }
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(StopwatchGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 2";
   visible = "1";
   helpTag = "0";

   new GuiWindowCtrl(StopwatchGUI_Window) {
      profile = "WM_WindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "45 32";
      extent = "200 100";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Stopwatch";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "1";
      canMaximize = "1";
      minSize = "50 50";
      closeCommand = "canvas.popDialog(StopwatchGui);";

      new GuiBitmapCtrl(bmpstopwatchbackground) {
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "3 21";
         extent = "192 75";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         bitmap = "dtb/client/wiggy/ui/Images/backgroundone";
         wrap = "0";
      };
      new GuiMLTextCtrl(txtStopwatchtxt) {
         profile = "GuiTextProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "80 25";
         extent = "200 40";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         text = "0:00:00.0";
         lineSpacing = "2";
         allowColorChars = "1";
         maxChars = "-1";
      };
      new GuiButtonCtrl(btnstartstop) {
         profile = "WM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "0 50";
         extent = "100 25";
         minExtent = "8 2";
         visible = "1";
         command = "stopwatch_startstop();";
         helpTag = "0";
         text = "Start/stop";
	 accelerator = "space";
         groupNum = "-1";
         buttonType = "PushButton";
      };
      new GuiButtonCtrl(btnReset) {
         profile = "WM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "100 50";
         extent = "100 25";
         minExtent = "8 2";
         visible = "1";
         command = "stopwatch_reset();";
         helpTag = "0";
         text = "[R]eset";
	 accelerator = "r";
         groupNum = "-1";
         buttonType = "PushButton";
      };
      new GuiButtonCtrl(btnclose) {
         profile = "WM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "0 75";
         extent = "200 25";
         minExtent = "8 2";
         visible = "1";
         command = "canvas.popDialog(stopwatchgui);";
         helpTag = "0";
         text = "Close";
	 accelerator = "escape";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
};
//--- OBJECT WRITE END ---

$WiggyMenu::Window[$WiggyMenu::Windows++] = StopwatchGUI_Window;
$WiggyMenu::Background[$WiggyMenu::Backgrounds++] = bmpstopwatchbackground;
$WiggyMenu::Text[$WiggyMenu::Texts++] = txtStopwatchtxt;

function StopwatchGUI::Onwake(%this) {
colorMenu($Pref::WP::WM::Background);
if($Pref::WP::WM::Background > 5)
  bmpstopwatchbackground.setVisible(1); //I dunno why this one is acting up.
}

$Stopwatch_hours=0;
$Stopwatch_minutes=0;
$Stopwatch_seconds=0;
$Stopwatch_milliseconds=0;

function Stopwatch_startStop() {
if(isEventPending($stopwatchUpdateTimer)) {
  cancel($stopwatchUpdateTimer);
  return;
}
$stopwatchUpdateTimer = schedule(100, 0, stopwatch_tick);
}

function stopwatch_tick() {
if(isEventPending($stopwatchUpdateTimer))
  cancel($stopwatchUpdateTimer);
$stopwatch_milliseconds++;
if($stopwatch_milliseconds >= 10) {
  $stopwatch_seconds++;
  $stopwatch_milliseconds -= 10;
}
if($stopwatch_seconds >= 60) {
  $stopwatch_minutes++;
  $stopwatch_seconds -= 60;
}
if($stopwatch_minutes >= 60) {
  $stopwatch_hours++;
  $stopwatch_minutes -= 60;
}
%t = $stopwatch_hours @ ":";
if($stopwatch_minutes < 10)
  %t = %t @ "0";
%t = %t @ $stopwatch_minutes @ ":";
if($stopwatch_seconds < 10)
  %t = %t @ "0";
txtStopwatchtxt.setText(%t @ $stopwatch_seconds @ "." @ $stopwatch_milliseconds);
$stopwatchUpdateTimer = schedule(97, 0, stopwatch_tick);
}

function stopwatch_reset() {
cancel($stopwatchUpdateTimer);
$Stopwatch_hours=0;
$Stopwatch_minutes=0;
$Stopwatch_seconds=0;
$Stopwatch_milliseconds=0;
txtStopwatchtxt.setText("0:00:00.0");
}

//This package makes the stopwatch background work with the WP background system.
//I imagine I'm going to be copy/pasting this a lot...

//Oh yeah.  If you, the reader, want to make a GUI with a WP background, feel free to rip this package off, because all you need is a GuiBitmapCtrl
package WP_Client_Stopwatch_Hooks {
function WPWindow() {
Parent::WPWindow();
StopwatchGUI_Window.setProfile(nametoID("WM_WindowProfile"));
}

function colorMenu(%tab) {
Parent::colorMenu(%tab);
nameToID(bmpstopwatchbackground).setVisible(0);
if(%tab > 5) {
 nameToID(bmpstopwatchbackground).setVisible(1);
 nameToID(bmpstopwatchbackground).setBitmap("dtb/client/wiggy/ui/Images/"@wiggymenu_return_backgroundname(%tab - 5));
}
}
};
activatepackage(WP_Client_Stopwatch_Hooks);

//More copypasta.
package WP_Client_Stopwatch_Chat_Hook {
function MessageHUD_Edit::Eval(%this) {
if(%this.getValue() $= "/stopwatch") {
  canvas.pushDialog(StopwatchGUI);
  MessageHUD.close();
  return;
}
Parent::Eval(%this);
}
};
activatepackage(WP_Client_Stopwatch_Chat_Hook);