if(isObject(BanManGUI)) {
  if(BanManGUI.isAwake()) {
    canvas.popDialog(BanManGUI);
    error("The Ban Manager GUI is already open!  Close a GUI before you execute it again, bonehead.");
  }
}

//--- OBJECT WRITE BEGIN ---
new GuiControl(BanManGui) {
   profile = "GuiDefaultProfile";
   horizSizing = "right";
   vertSizing = "bottom";
   position = "0 0";
   extent = "640 480";
   minExtent = "8 2";
   visible = "1";
   helpTag = "0";

   new GuiWindowCtrl(BanManGUIwindow) {
      profile = "WM_WindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "119 37";
      extent = "402 425";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Ban Manager Gui";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "0";
      canMaximize = "0";
      minSize = "50 50";
      closeCommand = "Canvas.popdialog(banManGui);";

      new GuiBitmapCtrl(bmpBanManGuiBackground) {
         profile = "GuiDefaultProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "3 21";
         extent = "396 400";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         bitmap = "dtb/client/wiggy/ui/Images/backgroundone";
         wrap = "0";
         WMbackground = 1;
      };

      new GuiScrollCtrl() {
         profile = "TBM_ScrollProfile";
         horizSizing = "width";
         vertSizing = "height";
         position = "11 36";
         extent = "380 339";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         willFirstRespond = "1";
         hScrollBar = "alwaysOff";
         vScrollBar = "alwaysOn";
         constantThumbHeight = "0";
         childMargin = "0 0";

         new GuiTextListCtrl(banManList) {
            profile = "GuiTextListProfile";
            horizSizing = "right";
            vertSizing = "bottom";
            position = "2 -1631";
            extent = "358 2672";
            minExtent = "8 2";
            visible = "1";
            altCommand = "removeBanFromList(banManList.getSelectedID());";
            helpTag = "0";
            enumerate = "0";
            resizeCell = "1";
            columns = "0 240";
            fitParentWidth = "1";
            clipColumnText = "0";
         };
      };
      new GuiMLTextCtrl(txtBanManGUI_DCAN) {
         profile = "GuiTextProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "11 379";
         extent = "250 18";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         text = "Double-click an entry to remove it.";
         lineSpacing = "2";
         allowColorChars = "1";
         maxChars = "-1";
      };
      new GuiTextEditCtrl(TxtaddbanIP) {
         profile = "GuiTextEditProfile";
         horizSizing = "width";
         vertSizing = "top";
         position = "74 400";
         extent = "316 18";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         maxLength = "255";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
      };
      new GuiButtonCtrl() {
         profile = "GuiButtonProfile";
         horizSizing = "right";
         vertSizing = "top";
         position = "11 398";
         extent = "58 22";
         minExtent = "8 2";
         visible = "1";
         command = "addBanToList();";
         helpTag = "0";
         text = "Add";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
};
//--- OBJECT WRITE END ---

$WiggyMenu::Window[$WiggyMenu::Windows++] = BanManGUIWindow;
$WiggyMenu::Background[$WiggyMenu::Backgrounds++] = bmpBanManGuiBackground;
$WiggyMenu::Text[$WiggyMenu::Texts++] = txtBanManGUI_DCAN;

function banManGui::onWake(%this) {
writeBanList();
loadBans();
$banManTog = 1;
colorMenu($Pref::WP::WM::Background);
}

function banManGui::onSleep(%this) {
$banManTog = 0;
}

function loadbans() {
banManList.clear();
%file = new FileObject();
%file.openForRead("tbm/server/ipbanlist.cs");
while(!%file.isEOF()) {
  %l = strReplace(%file.readLine(), ";", "=");
  if(%l !$= "") {
    %name = disectFileName(%l, "=", 0);
    %value = disectFileName(%l, "=", 1);
    if(getSubStr(%name, 6, 1) !$= "n")
      banManList.addRow(%i++, "Ban" SPC %i TAB %value);
  }
}
%file.close();
%file.delete();
}

loadBans();
$banManTog=0;

function banManTog(%val) {
if(%val && $banManTog == 0)
  canvas.pushDialog(banManGui);
else if(%val && $banManTog == 1)
  canvas.popDialog(banManGui);
}

function addBanToList() {
exec("tbm/server/ipbanlist.cs");
$Ban::numBans++;
$Ban::ip[$Ban::numBans] = TxtAddBanIP.getvalue();
writeBanList();
loadBans();
}

function removeBanFromList(%row) {
exec("tbm/server/ipbanlist.cs");
$Ban::IP[%row--] = "";
writeBanList();
loadBans();
}

function writebanlist() {
%list = new FileObject();
%list.openForWrite("tbm/server/ipbanlist.cs");
%cor=0;
for (%i=0; %i<$ban::numBans+1; %i++) {
  if ($ban::ip[%i]$="")
    %cor++;
  else
    %list.writeLine("$ban::ip["@%i-%cor@"]=\""@$ban::ip[%i]@"\";");
}
%list.writeLine("$Ban::numbans = "@$ban::numbans-%cor@";");
%list.close();
%list.delete();
exec("tbm/server/ipbanlist.cs");
}