//BEGIN
$WiggyPatch::ClientVersion = 1.24;
$WiggyPatch::TOBClientVersion = 2.3;

if($TOBVersion != $WiggyPatch::TOBClientVersion) {
  error("Warning!  This version of the WP (" @ $WiggyPatch::ClientVersion @ ") is intended for TOB version" SPC $WiggyPatch::TOBClientVersion @ ".");
  error("Loading will continue because I don't think stuff will get screwed up that badly.  Don't blame me if it does, though.");
}

//////////WP player list hooks//////////
package WiggyPatch_Client_Overwrites {
function handleClientJoin(%msgType, %msgString, %clientName, %clientId, %guid, %score, %isAI, %isAdmin, %isSuperAdmin, %isMod) {
Parent::handleClientJoin(%msgType, %msgString, %clientName, %clientId, %guid, %score, %isAI, %isAdmin, %isSuperAdmin, %isMod);
if(%isAI) return;
%tag = %isSuperAdmin? "[Super]":
      (%isAdmin? "[Admin]":
      (%isMod? "[Mod]":
      (%isAI? "[Bot]":
      "")));
%name =  StripMLControlChars(detag(%clientName)) @ %tag;
if (WiggyPlayerList.getRowNumById(%clientId) == -1)
  WiggyPlayerList.addRow(%clientId, %name);
else
  WiggyPlayerList.setRowById(%clientId, %name);
if ((%a = WiggyMassPMPlayerList.getRowNumById(%clientId)) == -1)
  WiggyMassPMPlayerList.addRow(%clientId, %name);
else {
  if(getSubStr(WiggyMassPMPlayerList.getRowText(%a), 0, 5) $= "*    ")
    WiggyMassPMPlayerList.setRowById(%clientId, "*    " @ %name);
  else
    WiggyMassPMPlayerList.setRowById(%clientId, %name);
}
}

function handleClientDrop(%msgType, %msgString, %clientName, %clientId) {
Parent::handleClientDrop(%msgType, %msgString, %clientName, %clientId);
wiggyPlayerList.removeRowByID(%clientId);
wiggyMassPMPlayerList.removeRowByID(%clientId);
}

function disconnectedCleanup() {
Parent::disconnectedCleanup();
WiggyPlayerList.clear();
WiggyPlayerList.addRow(-1, "--All--");
WiggyMassPMPlayerList.clear();
}


//////////Other stuff that should probably be under the WP stuff header//////////

function MessageHud_Edit::eval(%this) {
if(MessageHUD.MsgType == 2 && adminplayerlist.getSelectedID() == -1) { //This should prevent people from sending PMs to nobody in particular
  MessageHud.close();
  return;
}
if(MessageHud.MsgType == 0)  {
  %text = trim(%this.getValue());
  if(%text !$= "")
    say(%text);
  messageHUD.close();
  return;
}
Parent::eval(%this);
}

function LoadingGui::onWake(%this) {
Parent::onwake(%this);
Canvas.pushDialog(MainChatHud);
chatHud.attach(HudMessageVector);
moveMap.push();
if($connectedToServer == 0) {
  //Connecting to server, not changing map
  if($Pref::WP::Client::automessage !$= "")
    say($Pref::WP::Client::automessage);
  commandToServer('wiggyPatchVersion');
}
$connectedToServer = 1;
}

function MainMenuGui::OnWake(%this) {
Parent::onwake(%this);
 if(!$Pref::Server::WPinstalled) {
  moveMap.bind(keyboard, "alt w", wiggyTog);
  schedule(1000, 0, MessageBoxOK, "Hello!", "Hello.  This is probably your first time with the Wiggy Patch.  I bound the Wiggy Menu to Alt-W for you.", "");
  $Pref::Server::WPinstalled = 1;
  exportTBMPrefs();
}
$connectedToServer = 0;
}


function ChatHUD::Addline(%this, %line) {  //Link catching
if(strStr(%line,"http://") > 0 || strStr(%line,"https://") > 0) {
  for(%i = 0; %i < getWordCount(%line); %i++) {
    if(strStr(getWord(%line, %i),"http://") != -1 || strStr(getWord(%line, %i),"https://") != -1) {
      $WP_lastLink = detagColors(getWord(%line, %i));
    }
  }
}
Parent::AddLine(%this, %line);
}

function onServerMessage(%msg) {
if($Pref::WP::WM::EMI && (detagColors(%msg) $= "You are in EDIT mode." || detagColors(%msg) $= "You are in NORMAL mode.")) {
  bmpEMI.setBitmap("dtb/client/wiggy/ui/Thumbnail things/" @ (strPos(%msg, "EDIT" ) == -1 ? "normal" : "edit"));
  bmpEMI.setVisible($Pref::WP::WM::EMI);
}
else
  Parent::onServerMessage(%msg);
}

function screenHuds(%x) {
Parent::screenHuds(%x);
bmpEMI.setVisible(%x && $Pref::WP::WM::EMI);
}

function PersListDlg::onWake(%this) {
Parent::onWake(%this);
canvas.pushDialog(PersListSortDlg);
PersListDlg.add(PersListSortDlg);
PersListSortDlg.extent = "212 102";
//PersListSortDlg.position = getWord(PersListWindow.position, 0) SPC (getWord(PersListWindow.position, 1) + 280); //The first time a GUI is pushed to the canvas its position is based on the 640 by 480 extent it starts at.  It takes about 75 milliseconds to scale it up to the current canvas size and update its position accordingly.
for(%i = 0; %i <= 20; %i += 50)
  schedule(%i, 0, eval, "PersListSortDlg.position = getWord(PersListWindow.position, 0) SPC (getWord(PersListWindow.position, 1) + 280);");
}

function LoadSaveList(%d) {
if(txtPersListSort.getValue() $= "")
  Parent::loadSaveList(%d);
else
  LoadSaveListSort(txtPersListSort.getValue());
}

function iGobGUI::onWake(%this) {
Parent::onWake(%this);
//%w = iGobGUI.getObject(0);
iGobGUI.add(iGobSortGUI);
iGobSortGUI.extent = "270 102";
for(%i = 0; %i <= 20; %i += 50)
  schedule(%i, 0, eval, "iGobSortGUI.position = getWord(iGobWindow.position, 0) SPC (getWord(iGobWindow.position, 1) + 360);");
}

function LoadiGobList() {
if(txtiGobListSort.getValue() $= "")
  Parent::loadiGobList();
else
  LoadiGobListSort(txtiGobListSort.getValue());
}

};

activatepackage(WiggyPatch_Client_Overwrites);

if(!isObject(bmpEMI)) {
      new GuiBitmapCtrl(bmpEMI) {
         profile = "GuiDefaultProfile";
         horizSizing = "bottom";
         vertSizing = "right";
         position = getWord(StudCounter_HUD.position, 0) SPC getWord(StudCounter_HUD.position, 1) - 100;
         extent = "64 64";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         bitmap = "dtb/client/wiggy/ui/Thumbnail things/normal";
         wrap = "0";
         WMbackground = 1;
      };
      playGUI.add(bmpEMI);
      bmpEMI.setVisible($Pref::WP::WM::EMI);
}
for(%i = 0; %i <= 20; %i += 50)
  schedule(%i, 0, eval, "bmpEmi.position = getWord(StudCounter_HUD.position, 0) SPC getWord(StudCounter_HUD.position, 1) - 100;");

////////////////////////////////////////////////////////
////////////////////////WP stuff////////////////////////
////////////////////////////////////////////////////////

function WP_visitLink() { //Go ahead and guess
if($WP_lastLink $= "") {
 ChatHUD.addLine("\c2Sorry, but I have not found a link to follow.");
 return;
}
ChatHUD.addLine($WP_lastLink SPC "\c2has been copied to the clipboard, and possibly opened.");
goToWebPage($WP_lastLink);
setClipboard($WP_lastLink);
}

function clientCmdWiggyPatch_sendClientVersion(%client, %version) {
commandToServer('wiggyPatch_getClientVersion', $WiggyPatch::ClientVersion);
if(%version > $WiggyPatch::ClientVersion)
  ChatHud.addLine("Hey, this server has a newer version of the WP than you!  Go to http://tinyurl.com/wiggypatch to download the latest version.");
}

//////////Client commands//////////
//Old macro
function build(%X, %Y, %Z, %N) {
for(%i = 0; %i < %N; %i++) {
  commandToServer('plantBrick');
  commandToServer('shiftBrick', %X, %Y, %Z);
}
}

//New, much much longer macro
package WiggyPatch_Client_Macro {

function shiftBrickAway(%val) {if (%val) {if($macro) WPmacro_parse(1,0,0); Parent::shiftbrickaway(%val);}}
function sshiftBrickAway(%val) {if (%val) {if($macro) WPmacro_parse(10,0,0); Parent::sshiftbrickaway(%val);}}
function shiftBrickTowards(%val) {if (%val) {if($macro) WPmacro_parse(-1,0,0); Parent::shiftbricktowards(%val);}}
function sshiftBrickTowards(%val) {if (%val) {if($macro) WPmacro_parse(-10,0,0); Parent::sshiftbricktowards(%val);}}
function shiftBrickLeft(%val) {if (%val) {if($macro) WPmacro_parse(0,1,0); Parent::shiftbrickleft(%val);}}
function sshiftBrickLeft(%val) {if (%val) {if($macro) WPmacro_parse(0,10,0); Parent::sshiftbrickleft(%val);}}
function shiftBrickRight(%val) {if (%val) {if($macro) WPmacro_parse(0,-1,0); Parent::shiftbrickright(%val);}}
function sshiftBrickRight(%val) {if (%val) {if($macro) WPmacro_parse(0,-10,0); Parent::sshiftbrickright(%val);}}
function shiftBrickUp(%val) {if (%val) {if($macro) WPmacro_parse(0,0,3); Parent::shiftbrickup(%val);}}
function sshiftBrickUp(%val) {if (%val) {if($macro) WPmacro_parse(0,0,30); Parent::sshiftbrickup(%val);}}
function shiftBrickDown(%val) {if (%val) {if($macro) WPmacro_parse(0,0,-3); Parent::shiftbrickdown(%val);}}
function sshiftBrickDown(%val) {if (%val) {if($macro) WPmacro_parse(0,0,-30); Parent::sshiftbrickdown(%val);}}
function shiftBrickThirdUp(%val) {if (%val)	{if($macro) WPmacro_parse(0,0,1); Parent::shiftbrickthirdup(%val);}}
function shiftBrickThirdDown(%val) {if (%val) {if($macro) WPmacro_parse(0,0,-1); Parent::shiftbrickthirddown(%val);}}

function rotateBrickCW(%val) {
if(%val && $macro) addMacro("rotatebrickCW(1);");
Parent::RotateBrickCW(%val);
}

function rotateBrickCCW(%val) {
if(%val && $macro) addMacro("rotatebrickCCW(1);");
Parent::rotatebrickCCW(%val);
}

function plantBrick(%val) {
if(%val && $macro) addMacro("plantbrick(1);");
Parent::plantbrick(%val);
}

function scaleup(%val) {
if(%val && $macro) addMacro("scaleup(1);");
Parent::scaleup(%val);
}

function sscaleup(%val) {
if(%val && $macro) addMacro("sscaleup(1);");
Parent::sscaleup(%val);
}

function scaledown(%val) {
if(%val && $macro) addMacro("scaledown(1);");
Parent::scaledown(%val);
}

function sscaledown(%val) {
if(%val && $macro) addMacro("sscaledown(1);");
Parent::sscaledown(%val);
}

function handlecolorsetting(%color) {
if($colorsetting == 0 && $macro) addMacro("handlecolorsetting("@%color@");");
Parent::handlecolorsetting(%color);
}

function quickselectinv() {
if($macro) addMacro("commandToServer('quickchangebrick',"@QuickInv_list.getSelectedID()@");");
Parent::quickselectinv();
}

function QuickInv_list::OnSelect(%this, %id) {
if($macro) addMacro("commandToServer('quickchangebrick',"@%id@");");
Parent::OnSelect(%this, %id);
}

};

activatepackage(WiggyPatch_Client_Macro);

function addMacro(%entry) {
$MacroA[$Macrocount] = %entry;
$MacroCount++;
}

function startMacro() {
$macroCount = 0;
$macro = 1;
%forwardVec = serverconnection.getcontrolobject().getForwardVector();
%forwardX = getWord(%forwardVec, 0);
%forwardY = getWord(%forwardVec, 1);
$macroA[0] = "WPmacro_setup("@%forwardX@","@%forwardY@");";
$macroCount++;
}

function stopMacro() {
$macro = 0;
}

function playMacro() {
if($macro) stopMacro();
  for(%i = 0; %i < $MacroCount; %i++) {
    eval($MacroA[%i]);
  }
}

function echoMacro() {
if($macro) stopmacro();
  for(%i = 0; %i < $MacroCount; %i++) {
    echo($MacroA[%i]);
  }
}

function WPmacro_setup(%x, %y) {
$WPmacro_startX = %x;
$WPmacro_startY = %y;
}

if($WiggyPatch::ClientVersion > 3)  //It's only funny if I do it
$WiggyPatch::ClientVersion = 1.01;  //Or if I'm not around when you do it
                                    //And I'm always around

function WPmacro_parse(%x, %y, %z) {
%player = serverConnection.getControlObject();
%forwardVec = %player.getForwardVector();
%forwardX = getWord(%forwardVec, 0);
%forwardY = getWord(%forwardVec, 1);
//BORROWED from Vanilla
if(%forwardX > 0){
	if(%forwardX > mAbs(%forwardY)){
		//we are facing basically x+
		//this is the default, dont do anything
	}
	else{
		//we are closer to the y axis, but which direction?
		if(%forwardY > 0){
			//we are facing y +
			%newY = %x;
			%newX = -1 * %y; 
			%x = %newX;
			%y = %newY;
		}
		else{
			//we are facing y -
			%newY = -1 * %x;
			%newX = 1 * %y; 
			%x = %newX;
			%y = %newY;
		}
	}
}
else
{
	if(mAbs(%forwardX) > mAbs(%forwardY)){
		//we are facing basically x-
		//this backwards from default, reverse everything
		%x *= -1;
		%y *= -1;
	}
	else{
		//we are closer to the y axis, but which direction?
		if(%forwardY > 0){
			//we are facing y +
			%newY = %x;
			%newX = -1 * %y; 
			%x = %newX;
			%y = %newY;
		}
		else{
			//we are facing y -
			%newY = -1 * %x;
			%newX = 1 * %y; 
			%x = %newX;
			%y = %newY;
		}
	}
}

$MacroA[$MacroCount] = "WPmacro_unparse(" @ %x @ "," @ %y @ "," @ %z @ ");";
$MacroCount++;
}

function WPmacro_unparse(%x, %y, %z) {
%player = serverConnection.getControlObject();
%forwardVec = %player.getForwardVector();
%forwardX = $Wpmacro_startX;
%forwardY = $Wpmacro_startY;
//Borrowed
if(%forwardX > 0){
	if(%forwardX > mAbs(%forwardY)){
		//we are facing basically x+
		//this is the default, dont do anything
	}
	else{
		//we are closer to the y axis, but which direction?
		if(%forwardY > 0){
			//we are facing y +
			%newx = %y;
			%newy = -1 * %x; 
			%x = %newX;
			%y = %newY;
		}
		else{
			//we are facing y -
			%newX = -1 * %y;
			%newY = 1 * %x; 
			%x = %newX;
			%y = %newY;
		}
	}
}
else
{
	if(mAbs(%forwardX) > mAbs(%forwardY)){
		//we are facing basically x-
		//this backwards from default, reverse everything
		%x *= -1;
		%y *= -1;
	}
	else{
		//we are closer to the y axis, but which direction?
		if(%forwardY > 0){
			//we are facing y +
			%newX = %y;
			%newY = -1 * %x;
			%x = %newX;
			%y = %newY;
		}
		else{
			//we are facing y -
			%newX = -1 * %y;
			%newY = 1 * %x; 
			%x = %newX;
			%y = %newY;
		}
	}
}

commandToServer('shiftbrick', %x, %y, %z);
}

//////////Filter and commandToServer('messagesent') stuff//////////

//Hmm, I wonder what this does.
//Mostly here for ease of use, a global method for sending messages, and for macros and stuff
//Makes modifying the chat code with packages a breeze, by the way.
function say(%t) {
%t = WP_clientSideFilter(%t);
commandToServer('messageSent', activateHexCodes(activateChatColors(%t)));
}

function WP_clientSideFilter(%t) {
return %t;
//I'll finish this, I swear!
}


//////////Build/iGob list sorting//////////

if(!isObject(PersListSortDlg)) {
   new GuiWindowCtrl(PersListSortDlg) {
      profile = "TBM_WindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "0 0";
      extent = "12 12";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Search";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "1";
      canMaximize = "1";
      minSize = "50 50";
      closeCommand = "canvas.popDialog(PersListDlg);";

      new GuiTextEditCtrl(txtPersListSort) {
         profile = "GuiTextEditProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "16 35";
         extent = "180 18";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         maxLength = "255";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
         command = "if($Pref::WP::WM::PersListAutosort) LoadSaveListSort(txtPersListSort.getValue());";
         altCommand = "LoadSaveListSort(txtPersListSort.getValue());";
      };
      new GuiCheckBoxCtrl(PersListAutosearch) {
         profile = "TBM_CheckBoxProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "16 54";
         extent = "100 18";
         minExtent = "8 2";
         accelerator = "one";
         visible = "1";
         helpTag = "0";
         text = "Autosearch";
         groupNum = "-1";
         variable = "$Pref::WP::WM::PersListAutosort";
         buttonType = "ToggleButton";
      };
      new GuiButtonCtrl(PersListSortBtn) {
         profile = "TBM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "61 70";
         extent = "90 25";
         minExtent = "8 2";
         visible = "1";
         command = "LoadSaveListSort(txtPersListSort.getValue());";
         helpTag = "0";
         text = "Search";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
   PersListDlg.add(PersListSortDlg);
   PersListSortDlg.extent = "212 102";
}


function LoadSaveListSort(%string) { //Blatantly stolen from newListLoad.cs
PersList.clear();
if(%string $= "") {
	LoadSaveList();
	return;
}
%rowcount = 0;
%mission = filename($Server::MissionFile);
//The first character is case-sensitive.  I could just modify that letter but it's late at night and this is easier.
for(%a = 0; %a <= 1; %a++) {
	%loc = "tbm/tbmzips/*" @ (%a ? strlwr(%string) : strUpr(%string)) @ "*.save";
	for (%filename = findFirstFile(%loc); %filename !$= ""; %filename = findNextFile(%loc)) {
		%filename = strReplace(%fileName, "tbm/tbmzips/", "");
		echo(%filename);
		%c = getSubStr(%fileName, strLen(filename($Server::MissionFile)), 1);
		echo(%mission@" compare "@filename(getSubStr(%filename, 0, strstr(%filename, %c))));
		if (%mission !$= filename(getSubStr(%filename, 0, strstr(%filename, %c))))
			continue;
		while(strstr(%filename, %c) != -1)
			%filename = getSubStr(strchr(%filename, %c), 1, strlen(strchr(%filename, %c)));  //grab the 'name'
		PersList.addrow(%rowcount++, %filename);
	}
}
PersList.sort(0);
}

if(iGobGUI.getCount() == 1)
  iGobGUI.getObject(0).setName(iGobWindow);

if(!isObject(iGobSortGUI)) {
   new GuiWindowCtrl(iGobSortGUI) {
      profile = "TBM_WindowProfile";
      horizSizing = "center";
      vertSizing = "center";
      position = "0 0";
      extent = "12 12";
      minExtent = "8 2";
      visible = "1";
      helpTag = "0";
      text = "Search:";
      maxLength = "255";
      resizeWidth = "1";
      resizeHeight = "1";
      canMove = "1";
      canClose = "1";
      canMinimize = "1";
      canMaximize = "1";
      minSize = "50 50";
      closeCommand = "canvas.popDialog(iGobGUI);";

      new GuiTextEditCtrl(txtiGobListSort) {
         profile = "GuiTextEditProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "16 35";
         extent = "240 18";
         minExtent = "8 2";
         visible = "1";
         helpTag = "0";
         maxLength = "255";
         historySize = "0";
         password = "0";
         tabComplete = "0";
         sinkAllKeyEvents = "0";
         command = "if($Pref::WP::WM::iGobListAutosort) LoadiGobListSort(txtiGobListSort.getValue());";
         altCommand = "LoadiGobListSort(txtiGobListSort.getValue());";
      };
      new GuiCheckBoxCtrl(iGobListAutosearch) {
         profile = "TBM_CheckBoxProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "16 54";
         extent = "100 18";
         minExtent = "8 2";
         accelerator = "one";
         visible = "1";
         helpTag = "0";
         text = "Autosearch";
         groupNum = "-1";
         variable = "$Pref::WP::WM::iGobListAutosort";
         buttonType = "ToggleButton";
      };
      new GuiButtonCtrl(iGobListSortBtn) {
         profile = "TBM_ButtonProfile";
         horizSizing = "right";
         vertSizing = "bottom";
         position = "91 70";
         extent = "90 25";
         minExtent = "8 2";
         visible = "1";
         command = "LoadiGobListSort(txtiGobListSort.getValue());";
         helpTag = "0";
         text = "Search";
         groupNum = "-1";
         buttonType = "PushButton";
      };
   };
   iGobGUI.add(iGobSortGUI);
   iGobSortGUI.extent = "212 102";
}


function LoadSaveListSort(%string) {
PersList.clear();
if(%string $= "") {
	LoadSaveList();
	return;
}
%rowcount = 0;
%mission = filename($Server::MissionFile);
//The first character is case-sensitive.  I could just modify that letter but it's late at night and this is easier.
for(%a = 0; %a <= 1; %a++) {
	%loc = "tbm/tbmzips/*" @ (%a ? strlwr(%string) : strUpr(%string)) @ "*.save";
	for (%filename = findFirstFile(%loc); %filename !$= ""; %filename = findNextFile(%loc)) {
		%filename = strReplace(%fileName, "tbm/tbmzips/", "");
		echo(%filename);
		%c = getSubStr(%fileName, strLen(filename($Server::MissionFile)), 1);
		echo(%mission@" compare "@filename(getSubStr(%filename, 0, strstr(%filename, %c))));
		if (%mission !$= filename(getSubStr(%filename, 0, strstr(%filename, %c))))
			continue;
		while(strstr(%filename, %c) != -1)
			%filename = getSubStr(strchr(%filename, %c), 1, strlen(strchr(%filename, %c)));  //grab the 'name'
		PersList.addrow(%rowcount++, %filename);
	}
}
PersList.sort(0);
}

function LoadiGobListSort(%string) {
iGoblist.clear();
if(%string $= "") {
	LoadiGobList();
	return;
}
%rowcount = 0;
for(%a = 0; %a <= 1; %a++) {
	%loc = "tbm/client/iGob/*" @ (%a ? strlwr(%string) : strUpr(%string)) @ "*.save";
	for (%filename = findFirstFile(%loc); %filename !$= ""; %filename = findNextFile(%loc)) {
		if(strstr(%filename,"iGob_temp") != -1)
			continue;
		%brickcount = getlinecount(%filename);
		%filename = strreplace(strreplace(%filename,".save",""),"tbm/client/iGob/","");
		iGoblist.addrow(%rowcount++, %filename TAB %brickcount);
	}
}
iGoblist.sort(0);
}

//////////Privilege stuff//////////

function clientCmdGetPrivileges(%name, %IP, %poon, %mute, %brick, %vehicle, %weapon, %paint, %igob, %privs, %money, %god, %edit, %camera, %jet) {
if(%name $= "")
return;

wiggyPrivilegeWindow.setText(%name@"'\s Privileges");
%txtpoon = "Allowed";
%txtmute = "Allowed";
%txtbrick = "Allowed";
%txtvehicle = "Allowed";
%txtweapon = "Allowed";
%txtpaint = "Allowed";
%txtigob = "Allowed";
%txtPrivs = "Allowed";
%txtmoney = "Allowed";
%txtgod = "Vincible";
%txtedit = "Allowed";
%txtcamera = "Allowed";
%txtJet = "Allowed";
if(%poon)
  %txtpoon = "Forbidden";
if(%mute)
  %txtmute = "Forbidden";
if(%brick)
  %txtbrick = "Forbidden";
if(%vehicle)
  %txtvehicle = "Forbidden";
if(%weapon)
  %txtweapon = "Forbidden";
if(%paint)
  %txtpaint = "Forbidden";
if(%igob)
  %txtigob = "Forbidden";
if(%privs)
  %txtPrivs = "Forbidden";
if(%money)
  %txtmoney = "Forbidden";
if(%god)
  %txtgod = "Invincible";
if(%edit)
  %txtedit = "Forbidden";
if(%camera)
  %txtcamera = "Forbidden";
if(%jet)
  %txtJet = "Forbidden";

%color = decimalToHex(getWord($Pref::WP::WM::TextColor, 0), 2) @ decimalToHex(getWord($Pref::WP::WM::TextColor, 1), 2) @ decimalToHex(getWord($Pref::WP::WM::TextColor, 2), 2);

txtPrivname.setText("<color:" @ %color @ ">" @ %name);
txtPrivIP.setText("<color:" @ %color @ ">" @ %IP);
txtPrivpoon.setText("<color:" @ %color @ ">" @ %txtpoon);
txtPrivmute.setText("<color:" @ %color @ ">" @ %txtmute);
txtPrivbrick.setText("<color:" @ %color @ ">" @ %txtbrick);
txtPrivvehicle.setText("<color:" @ %color @ ">" @ %txtvehicle);
txtPrivweapons.setText("<color:" @ %color @ ">" @ %txtweapon);
txtPrivpaint.setText("<color:" @ %color @ ">" @ %txtpaint);
txtPrivigob.setText("<color:" @ %color @ ">" @ %txtigob);
txtPrivmoney.setText("<color:" @ %color @ ">" @ %txtmoney);
txtPrivgod.setText("<color:" @ %color @ ">" @ %txtgod);
txtPrivedit.setText("<color:" @ %color @ ">" @ %txtedit);
txtPrivcamera.setText("<color:" @ %color @ ">" @ %txtcamera);
txtPrivJet.setText("<color:" @ %color @ ">" @ %txtJet);
txtPrivprivs.setText("<color:" @ %color @ ">" @ %txtPrivs);
canvas.popDialog(wiggyMenu);
Canvas.pushDialog(wiggyprivilegeGui);
}

function wiggyprivilegeGUI::OnWake(%this) {
}

function wiggyprivilegeGUI::onSleep(%this) {
wiggyPrivilegeWindow.settext("Player Privileges");
txtPrivname.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivIP.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivpoon.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivmute.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivbrick.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivvehicle.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivweapons.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivpaint.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivigob.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivmoney.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivprivs.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivedit.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivcamera.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivJet.setText("<color:" @ %color @ ">" @ "Unknown");
txtPrivgod.setText("<color:" @ %color @ ">" @ "Unknown");
}

function wigTogpoon() {
commandToServer('wigTogpoon', wiggyPlayerList.getSelectedID());
}

function wigTogigob() {
commandToServer('wigTogigob', wiggyPlayerList.getSelectedID());
}

function wigTogmute() {
commandToServer('wigTogmute', wiggyPlayerList.getSelectedID());
}

function wigTogbrick() {
commandToServer('wigTogbrick', wiggyPlayerList.getSelectedID());
}

function wigTogvehicle() {
commandToServer('wigTogvehicle', wiggyPlayerList.getSelectedID());
}

function wigTogweapon() {
commandToServer('wigTogweapon', wiggyPlayerList.getSelectedID());
}

function wigTogpaint() {
commandToServer('wigTogpaint', wiggyPlayerList.getSelectedID());
}

function wigTogmoney() {
commandToServer('wigTogmoney', wiggyPlayerList.getSelectedID());
}

function wigTogprivs() {
commandToServer('wigTogprivs', wiggyPlayerList.getSelectedID());
}

function wigToggod() {
commandToServer('wigToggod', wiggyPlayerList.getSelectedID());
}

function wigTogedit() {
commandToServer('wigTogedit', wiggyPlayerList.getSelectedID());
}

function wigTogcamera() {
commandToServer('wigTogcamera', wiggyPlayerList.getSelectedID());
}

function wigTogJet() {
commandToServer('wigTogJet', wiggyPlayerList.getSelectedID());
}

function closePrivGui() {
Canvas.popDialog(wiggyPrivilegeGUI);
}

function WPDynamicLoader_Client() {
setModPaths(getModPaths());
%loc = "dtb/client/dynamic/*.cs";
%rowcount = 0;
for (%filename = findFirstFile(%loc); %filename !$= ""; %filename = findNextFile(%loc)) {
  if(getLineCount(%filename))
    exec(%filename);
}
}

function activateChatColors(%text) {
//Support function for activating chat colors
%text = strReplace(%text,"/c0","\c0");
%text = strReplace(%text,"/c1","\c1");
%text = strReplace(%text,"/c2","\c2");
%text = strReplace(%text,"/c3","\c3");
%text = strReplace(%text,"/c4","\c4");
%text = strReplace(%text,"/c5","\c5");
%text = strReplace(%text,"/c6","\c6");
%text = strReplace(%text,"/c7","\c7");
%text = strReplace(%text,"/c8","\c8");
%text = strReplace(%text,"/c9","\c9");
return %text;
}

function activateHexCodes(%text) {
//Support function for activating hex codes
%text = strReplace(%text,"/x00","\x00");
%text = strReplace(%text,"/x01","\x01");
%text = strReplace(%text,"/x02","\x02");
%text = strReplace(%text,"/x03","\x03");
%text = strReplace(%text,"/x04","\x04");
%text = strReplace(%text,"/x05","\x05");
%text = strReplace(%text,"/x06","\x06");
%text = strReplace(%text,"/x07","\x07");
%text = strReplace(%text,"/x08","\x08");
%text = strReplace(%text,"/x09","\x09");
%text = strReplace(%text,"/x0a","\x0a");
%text = strReplace(%text,"/x0b","\x0b");
%text = strReplace(%text,"/x0c","\x0c");
%text = strReplace(%text,"/x0d","\x0d");
%text = strReplace(%text,"/x0e","\x0e");
%text = strReplace(%text,"/x0f","\x0f");
%text = strReplace(%text,"/x10","\x10");
%text = strReplace(%text,"/x11","\x11");
%text = strReplace(%text,"/x12","\x12");
%text = strReplace(%text,"/x13","\x13");
%text = strReplace(%text,"/x14","\x14");
%text = strReplace(%text,"/x15","\x15");
%text = strReplace(%text,"/x16","\x16");
%text = strReplace(%text,"/x17","\x17");
%text = strReplace(%text,"/x18","\x18");
%text = strReplace(%text,"/x19","\x19");
%text = strReplace(%text,"/x1a","\x1a");
%text = strReplace(%text,"/x1b","\x1b");
%text = strReplace(%text,"/x1c","\x1c");
%text = strReplace(%text,"/x1d","\x1d");
%text = strReplace(%text,"/x1e","\x1e");
%text = strReplace(%text,"/x1f","\x1f");
%text = strReplace(%text,"/x20","\x20");
%text = strReplace(%text,"/x21","\x21");
%text = strReplace(%text,"/x22","\x22");
%text = strReplace(%text,"/x23","\x23");
%text = strReplace(%text,"/x24","\x24");
%text = strReplace(%text,"/x25","\x25");
%text = strReplace(%text,"/x26","\x26");
%text = strReplace(%text,"/x27","\x27");
%text = strReplace(%text,"/x28","\x28");
%text = strReplace(%text,"/x29","\x29");
%text = strReplace(%text,"/x2a","\x2a");
%text = strReplace(%text,"/x2b","\x2b");
%text = strReplace(%text,"/x2c","\x2c");
%text = strReplace(%text,"/x2d","\x2d");
%text = strReplace(%text,"/x2e","\x2e");
%text = strReplace(%text,"/x2f","\x2f");
%text = strReplace(%text,"/x30","\x30");
%text = strReplace(%text,"/x31","\x31");
%text = strReplace(%text,"/x32","\x32");
%text = strReplace(%text,"/x33","\x33");
%text = strReplace(%text,"/x34","\x34");
%text = strReplace(%text,"/x35","\x35");
%text = strReplace(%text,"/x36","\x36");
%text = strReplace(%text,"/x37","\x37");
%text = strReplace(%text,"/x38","\x38");
%text = strReplace(%text,"/x39","\x39");
%text = strReplace(%text,"/x3a","\x3a");
%text = strReplace(%text,"/x3b","\x3b");
%text = strReplace(%text,"/x3c","\x3c");
%text = strReplace(%text,"/x3d","\x3d");
%text = strReplace(%text,"/x3e","\x3e");
%text = strReplace(%text,"/x3f","\x3f");
%text = strReplace(%text,"/x40","\x40");
%text = strReplace(%text,"/x41","\x41");
%text = strReplace(%text,"/x42","\x42");
%text = strReplace(%text,"/x43","\x43");
%text = strReplace(%text,"/x44","\x44");
%text = strReplace(%text,"/x45","\x45");
%text = strReplace(%text,"/x46","\x46");
%text = strReplace(%text,"/x47","\x47");
%text = strReplace(%text,"/x48","\x48");
%text = strReplace(%text,"/x49","\x49");
%text = strReplace(%text,"/x4a","\x4a");
%text = strReplace(%text,"/x4b","\x4b");
%text = strReplace(%text,"/x4c","\x4c");
%text = strReplace(%text,"/x4d","\x4d");
%text = strReplace(%text,"/x4e","\x4e");
%text = strReplace(%text,"/x4f","\x4f");
%text = strReplace(%text,"/x50","\x50");
%text = strReplace(%text,"/x51","\x51");
%text = strReplace(%text,"/x52","\x52");
%text = strReplace(%text,"/x53","\x53");
%text = strReplace(%text,"/x54","\x54");
%text = strReplace(%text,"/x55","\x55");
%text = strReplace(%text,"/x56","\x56");
%text = strReplace(%text,"/x57","\x57");
%text = strReplace(%text,"/x58","\x58");
%text = strReplace(%text,"/x59","\x59");
%text = strReplace(%text,"/x5a","\x5a");
%text = strReplace(%text,"/x5b","\x5b");
%text = strReplace(%text,"/x5c","\x5c");
%text = strReplace(%text,"/x5d","\x5d");
%text = strReplace(%text,"/x5e","\x5e");
%text = strReplace(%text,"/x5f","\x5f");
%text = strReplace(%text,"/x60","\x60");
%text = strReplace(%text,"/x61","\x61");
%text = strReplace(%text,"/x62","\x62");
%text = strReplace(%text,"/x63","\x63");
%text = strReplace(%text,"/x64","\x64");
%text = strReplace(%text,"/x65","\x65");
%text = strReplace(%text,"/x66","\x66");
%text = strReplace(%text,"/x67","\x67");
%text = strReplace(%text,"/x68","\x68");
%text = strReplace(%text,"/x69","\x69");
%text = strReplace(%text,"/x6a","\x6a");
%text = strReplace(%text,"/x6b","\x6b");
%text = strReplace(%text,"/x6c","\x6c");
%text = strReplace(%text,"/x6d","\x6d");
%text = strReplace(%text,"/x6e","\x6e");
%text = strReplace(%text,"/x6f","\x6f");
%text = strReplace(%text,"/x70","\x70");
%text = strReplace(%text,"/x71","\x71");
%text = strReplace(%text,"/x72","\x72");
%text = strReplace(%text,"/x73","\x73");
%text = strReplace(%text,"/x74","\x74");
%text = strReplace(%text,"/x75","\x75");
%text = strReplace(%text,"/x76","\x76");
%text = strReplace(%text,"/x77","\x77");
%text = strReplace(%text,"/x78","\x78");
%text = strReplace(%text,"/x79","\x79");
%text = strReplace(%text,"/x7a","\x7a");
%text = strReplace(%text,"/x7b","\x7b");
%text = strReplace(%text,"/x7c","\x7c");
%text = strReplace(%text,"/x7d","\x7d");
%text = strReplace(%text,"/x7e","\x7e");
%text = strReplace(%text,"/x7f","\x7f");
%text = strReplace(%text,"/x80","\x80");
%text = strReplace(%text,"/x81","\x81");
%text = strReplace(%text,"/x82","\x82");
%text = strReplace(%text,"/x83","\x83");
%text = strReplace(%text,"/x84","\x84");
%text = strReplace(%text,"/x85","\x85");
%text = strReplace(%text,"/x86","\x86");
%text = strReplace(%text,"/x87","\x87");
%text = strReplace(%text,"/x88","\x88");
%text = strReplace(%text,"/x89","\x89");
%text = strReplace(%text,"/x8a","\x8a");
%text = strReplace(%text,"/x8b","\x8b");
%text = strReplace(%text,"/x8c","\x8c");
%text = strReplace(%text,"/x8d","\x8d");
%text = strReplace(%text,"/x8e","\x8e");
%text = strReplace(%text,"/x8f","\x8f");
%text = strReplace(%text,"/x90","\x90");
%text = strReplace(%text,"/x91","\x91");
%text = strReplace(%text,"/x92","\x92");
%text = strReplace(%text,"/x93","\x93");
%text = strReplace(%text,"/x94","\x94");
%text = strReplace(%text,"/x95","\x95");
%text = strReplace(%text,"/x96","\x96");
%text = strReplace(%text,"/x97","\x97");
%text = strReplace(%text,"/x98","\x98");
%text = strReplace(%text,"/x99","\x99");
%text = strReplace(%text,"/x9a","\x9a");
%text = strReplace(%text,"/x9b","\x9b");
%text = strReplace(%text,"/x9c","\x9c");
%text = strReplace(%text,"/x9d","\x9d");
%text = strReplace(%text,"/x9e","\x9e");
%text = strReplace(%text,"/x9f","\x9f");
%text = strReplace(%text,"/xa0","\xa0");
%text = strReplace(%text,"/xa1","\xa1");
%text = strReplace(%text,"/xa2","\xa2");
%text = strReplace(%text,"/xa3","\xa3");
%text = strReplace(%text,"/xa4","\xa4");
%text = strReplace(%text,"/xa5","\xa5");
%text = strReplace(%text,"/xa6","\xa6");
%text = strReplace(%text,"/xa7","\xa7");
%text = strReplace(%text,"/xa8","\xa8");
%text = strReplace(%text,"/xa9","\xa9");
%text = strReplace(%text,"/xaa","\xaa");
%text = strReplace(%text,"/xab","\xab");
%text = strReplace(%text,"/xac","\xac");
%text = strReplace(%text,"/xad","\xad");
%text = strReplace(%text,"/xae","\xae");
%text = strReplace(%text,"/xaf","\xaf");
%text = strReplace(%text,"/xb0","\xb0");
%text = strReplace(%text,"/xb1","\xb1");
%text = strReplace(%text,"/xb2","\xb2");
%text = strReplace(%text,"/xb3","\xb3");
%text = strReplace(%text,"/xb4","\xb4");
%text = strReplace(%text,"/xb5","\xb5");
%text = strReplace(%text,"/xb6","\xb6");
%text = strReplace(%text,"/xb7","\xb7");
%text = strReplace(%text,"/xb8","\xb8");
%text = strReplace(%text,"/xb9","\xb9");
%text = strReplace(%text,"/xba","\xba");
%text = strReplace(%text,"/xbb","\xbb");
%text = strReplace(%text,"/xbc","\xbc");
%text = strReplace(%text,"/xbd","\xbd");
%text = strReplace(%text,"/xbe","\xbe");
%text = strReplace(%text,"/xbf","\xbf");
%text = strReplace(%text,"/xc0","\xc0");
%text = strReplace(%text,"/xc1","\xc1");
%text = strReplace(%text,"/xc2","\xc2");
%text = strReplace(%text,"/xc3","\xc3");
%text = strReplace(%text,"/xc4","\xc4");
%text = strReplace(%text,"/xc5","\xc5");
%text = strReplace(%text,"/xc6","\xc6");
%text = strReplace(%text,"/xc7","\xc7");
%text = strReplace(%text,"/xc8","\xc8");
%text = strReplace(%text,"/xc9","\xc9");
%text = strReplace(%text,"/xca","\xca");
%text = strReplace(%text,"/xcb","\xcb");
%text = strReplace(%text,"/xcc","\xcc");
%text = strReplace(%text,"/xcd","\xcd");
%text = strReplace(%text,"/xce","\xce");
%text = strReplace(%text,"/xcf","\xcf");
%text = strReplace(%text,"/xd0","\xd0");
%text = strReplace(%text,"/xd1","\xd1");
%text = strReplace(%text,"/xd2","\xd2");
%text = strReplace(%text,"/xd3","\xd3");
%text = strReplace(%text,"/xd4","\xd4");
%text = strReplace(%text,"/xd5","\xd5");
%text = strReplace(%text,"/xd6","\xd6");
%text = strReplace(%text,"/xd7","\xd7");
%text = strReplace(%text,"/xd8","\xd8");
%text = strReplace(%text,"/xd9","\xd9");
%text = strReplace(%text,"/xda","\xda");
%text = strReplace(%text,"/xdb","\xdb");
%text = strReplace(%text,"/xdc","\xdc");
%text = strReplace(%text,"/xdd","\xdd");
%text = strReplace(%text,"/xde","\xde");
%text = strReplace(%text,"/xdf","\xdf");
%text = strReplace(%text,"/xe0","\xe0");
%text = strReplace(%text,"/xe1","\xe1");
%text = strReplace(%text,"/xe2","\xe2");
%text = strReplace(%text,"/xe3","\xe3");
%text = strReplace(%text,"/xe4","\xe4");
%text = strReplace(%text,"/xe5","\xe5");
%text = strReplace(%text,"/xe6","\xe6");
%text = strReplace(%text,"/xe7","\xe7");
%text = strReplace(%text,"/xe8","\xe8");
%text = strReplace(%text,"/xe9","\xe9");
%text = strReplace(%text,"/xea","\xea");
%text = strReplace(%text,"/xeb","\xeb");
%text = strReplace(%text,"/xec","\xec");
%text = strReplace(%text,"/xed","\xed");
%text = strReplace(%text,"/xee","\xee");
%text = strReplace(%text,"/xef","\xef");
%text = strReplace(%text,"/xf0","\xf0");
%text = strReplace(%text,"/xf1","\xf1");
%text = strReplace(%text,"/xf2","\xf2");
%text = strReplace(%text,"/xf3","\xf3");
%text = strReplace(%text,"/xf4","\xf4");
%text = strReplace(%text,"/xf5","\xf5");
%text = strReplace(%text,"/xf6","\xf6");
%text = strReplace(%text,"/xf7","\xf7");
%text = strReplace(%text,"/xf8","\xf8");
%text = strReplace(%text,"/xf9","\xf9");
%text = strReplace(%text,"/xfa","\xfa");
%text = strReplace(%text,"/xfb","\xfb");
%text = strReplace(%text,"/xfc","\xfc");
%text = strReplace(%text,"/xfd","\xfd");
%text = strReplace(%text,"/xfe","\xfe");
%text = strReplace(%text,"/xff","\xff");
return %text;
}

function exwpc() {
exec("dtb/client/wiggy/wiggymenu.cs");
}

function wpHover(%b) {
if(%b)
  commandToServer('hover');
}

function wpCopyBrick(%b) {
if(%b)
  commandToServer('copySelectedBrick');
}

//Executed when this file is loaded

addRemap("[WP]Hover", "wpHover");
addRemap("[WP]Copy brick", "wpCopyBrick");

if(getLineCount("dtb/client/Dynamic/Gamemodes/CSpleef.cs") $= "") {
  %file = new FileObject();
  %file.openForWrite("dtb/client/Dynamic/Gamemodes/CSpleef.cs");

  %file.writeLine("$GamemodeVar[\"CSpleef\", 1] = \"MatchCount\";");

  %file.writeLine("$GamemodeVarName[\"CSpleef\", 1] = \"Matches to win game\";");

  %file.writeLine("$GamemodeVarType[\"CSpleef\", 1] = \"Intabove 1\";");

  %file.writeLine("$GamemodeVar[\"CSpleef\", 2] = \"StartingWeapons\";");

  %file.writeLine("$GamemodeVarName[\"CSpleef\", 2] = \"Starting weapon(s)\";");

  %file.writeLine("$GamemodeVarType[\"CSpleef\", 2] = \"String\";");

  %file.writeLine("$GamemodeVar[\"CSpleef\", 3] = \"SpawnProtect\";");

  %file.writeLine("$GamemodeVarName[\"CSpleef\", 3] = \"Match start delay (s)\";");

  %file.writeLine("$GamemodeVarType[\"CSpleef\", 3] = \"Intabove 3\";");

  %file.writeLine("$GamemodeVarCount[\"CSpleef\"] = 3;");

  %file.writeLine("");

  %file.writeLine("//Defaults go here, although this might change");

  %file.writeLine("if($Pref::Gamemode::CSpleef::MatchCount $= \"\")");

  %file.writeLine("  $Pref::Gamemode::CSpleef::MatchCount = 3;");

  %file.writeLine("if($Pref::Gamemode::CSpleef::StartingWeapons $= \"\")");

  %file.writeLine("  $Pref::Gamemode::CSpleef::StartingWeapons = \"Pickaxe\";");

  %file.writeLine("if($Pref::Gamemode::CSpleef::SpawnProtect $= \"\")");

  %file.writeLine("  $Pref::Gamemode::CSpleef::SpawnProtect = 5;");
  %file.close();
  %file.delete();
}

if(getLineCount("dtb/client/Dynamic/Gamemodes/TSpleef.cs") $= "") {
  %file = new FileObject();
  %file.openForWrite("dtb/client/Dynamic/Gamemodes/TSpleef.cs");

  %file.writeLine("$GamemodeVar[\"TSpleef\", 1] = \"MatchCount\";");

  %file.writeLine("$GamemodeVarName[\"TSpleef\", 1] = \"Matches to win game\";");

  %file.writeLine("$GamemodeVarType[\"TSpleef\", 1] = \"Intabove 1\";");

  %file.writeLine("$GamemodeVar[\"TSpleef\", 2] = \"StartingWeapons\";");

  %file.writeLine("$GamemodeVarName[\"TSpleef\", 2] = \"Starting weapon(s)\";");

  %file.writeLine("$GamemodeVarType[\"TSpleef\", 2] = \"String\";");

  %file.writeLine("$GamemodeVar[\"TSpleef\", 3] = \"SpawnProtect\";");

  %file.writeLine("$GamemodeVarName[\"TSpleef\", 3] = \"Match start delay (s)\";");

  %file.writeLine("$GamemodeVarType[\"TSpleef\", 3] = \"Intabove 3\";");

  %file.writeLine("$GamemodeVarCount[\"TSpleef\"] = 3;");

  %file.writeLine("");

  %file.writeLine("//Defaults go here, although this might change");

  %file.writeLine("if($Pref::Gamemode::TSpleef::MatchCount $= \"\")");

  %file.writeLine("  $Pref::Gamemode::TSpleef::MatchCount = 3;");

  %file.writeLine("if($Pref::Gamemode::TSpleef::StartingWeapons $= \"\")");

  %file.writeLine("  $Pref::Gamemode::TSpleef::StartingWeapons = \"Pickaxe\";");

  %file.writeLine("if($Pref::Gamemode::TSpleef::SpawnProtect $= \"\")");

  %file.writeLine("  $Pref::Gamemode::TSpleef::SpawnProtect = 5;");
  %file.close();
  %file.delete();
}

if(getLineCount("dtb/client/Dynamic/Gamemodes/HideNSeek.cs") $= "") {
  %file = new FileObject();
  %file.openForWrite("dtb/client/Dynamic/Gamemodes/HideNSeek.cs");


  %file.writeLine("//Hee hee, Hide N Seek");
  %file.writeLine("");

  %file.writeLine("$GamemodeVar[\"HideNSeek\", 1] = \"HideLength\";");

  %file.writeLine("$GamemodeVarName[\"HideNSeek\", 1] = \"Hide phase length (s)\";");

  %file.writeLine("$GamemodeVarType[\"HideNSeek\", 1] = \"Intabove 5\";");

  %file.writeLine("$GamemodeVar[\"HideNSeek\", 2] = \"RedWeapons\";");

  %file.writeLine("$GamemodeVarName[\"HideNSeek\", 2] = \"Red team weapon(s)\";");

  %file.writeLine("$GamemodeVarType[\"HideNSeek\", 2] = \"String\";");

  %file.writeLine("$GamemodeVar[\"HideNSeek\", 3] = \"BlueWeapons\";");

  %file.writeLine("$GamemodeVarName[\"HideNSeek\", 3] = \"Blue team weapon(s)\";");

  %file.writeLine("$GamemodeVarType[\"HideNSeek\", 3] = \"String\";");

  %file.writeLine("$GamemodeVar[\"HideNSeek\", 4] = \"RoundLength\";");

  %file.writeLine("$GamemodeVarName[\"HideNSeek\", 4] = \"Seek phase length (s)\";");

  %file.writeLine("$GamemodeVarType[\"HideNSeek\", 4] = \"Intabove 15\";");

  %file.writeLine("$GamemodeVarCount[\"HideNSeek\"] = 4;");
  %file.writeLine("");

  %file.writeLine("//Defaults go here, although this might change");

  %file.writeLine("if($Pref::Gamemode::HideNSeek::HideLength $= \"\")");

  %file.writeLine("  $Pref::Gamemode::HideNSeek::HideLength = 10;");

  %file.writeLine("if($Pref::Gamemode::HideNSeek::RedWeapons $= \"\")");

  %file.writeLine("  $Pref::Gamemode::HideNSeek::RedWeapons = \"legoSniper\";");

  %file.writeLine("if($Pref::Gamemode::HideNSeek::BlueWeapons $= \"\")");

  %file.writeLine("  $Pref::Gamemode::HideNSeek::BlueWeapons = \"psyBeam\";");

  %file.writeLine("if($Pref::Gamemode::HideNSeek::RoundLength $= \"\")");

  %file.writeLine("  $Pref::Gamemode::HideNSeek::RoundLength = 60;");
  %file.close();
  %file.delete();
}


WPDynamicLoader_Client();
